"""
Pravljenje listi generatora. Najlakse je napraviti ukoliko se prvo napravi petlja i sintaksa je sledeca:
[element for element in kolekcija if neki_uslov]
"""
lista = []
for i in range(10):
  if i%2==0:
    lista.append(i)
print(lista)

lista1 = [i for i in range(10) if i%2==0]
print(lista1)

parovi = []
xs = [1, 2, 3]
ys = [4, 5, 6]
for i in range(len(xs)):
  parovi.append((xs[i], ys[i]))
print(parovi)
parovi2 = [(xs[i], ys[i]) for i in range(len(xs))]
print(parovi2)

parovi_dekart = []
for i in range(len(xs)):

  for j in range(len(ys)):
    parovi_dekart.append((xs[i], ys[j]))
print(parovi_dekart)
parovi_dekart1 = [(xs[i], ys[j]) for i in range(len(xs)) for j in range(len(ys))]
print(parovi_dekart1)

liste = [[1, 2, 3], [4, 5, 6, 7], [7, 8, 9]]
lista_zbirova = [sum(l) for l in liste]
print(lista_zbirova)
lista = [10, 9, 11, -4, 8, 14]
ostaci = [element%3 for element in lista]
print(ostaci)

def uvecaj(x, uvecanje=3):
  return x + uvecanje
def uvecaj3(x):
  return x + 3
def uvecaj5(x):
  return x + 5
Uvecaj = lambda x, uvecanje=3: x+uvecanje
lista = [1, 2, 10, 203, -10]
lista_uvecana = [Uvecaj(e, 4) for e in lista]
print(lista_uvecana)

def veci(x, y=5):
  return x > y
def veci5(x):
  return x>5
def veci10(x):
  return x>10
Veci = lambda x, y=5: x > y
lista_vecih5 = [e for e in lista if Veci(e)]
print(lista_vecih5)

print(sum(lista))
"""
1 2 3
zbir = 0
((0 + 1) + 2) + 3
akumulator on cuva do sada nadjenu vrednost
element
"""
#funkcije mapiranja, filtriranja i redukovanja
from functools import reduce
print(reduce(lambda x, y: x+y, lista))
print(list(map(Uvecaj, lista)))
print(list(filter(Veci, lista)))

x = int(input())
y = int(input())
suma = lambda x, y: x + y
print("suma: {0:d}".format(suma(x, y)))

xs = [1, 2, 3]
ys = [4, 5, 6, 7, 8]
parovi = list(zip(xs, ys))
print(parovi)

niska = "niskaSAVelikim.123"
#liste generatori
niska1 = [karakter.upper() for karakter in niska]
niska1 = "".join(niska1)
print(niska1)
#map
niska2 = list(map(lambda x: x.upper(), niska))
niska2 = "".join(niska2)
print(niska2)

#liste generatori filter
niska3 = [karakter for karakter in niska if not karakter.isalpha()]
niska3 = "".join(niska3)
print(niska3)

#filter
niska4 = list(filter(lambda x: not x.isalpha(), niska))
niska4 = "".join(niska4)
print(niska4)

"""ITERTOOLS
Napraviti niz od 10 elemenata. (count)
"""

import itertools
lista = list(itertools.takewhile(lambda x: x<=10, itertools.count(1)))
print(lista)

"""Ponoviti sekvencu "abc" 5 puta."""

print("abc"*5)
print("".join(list(itertools.repeat("abc", 5))))

"""Spojiti elemente listi ['a', 'b', 'c'] i [1, 2, 3]."""

l1 = ['a', 'b', 'c', 'd']
l2 = [1, 2, 3]
lista1 = list(zip(l1, l2))
print(lista1)
lista2 = list(itertools.zip_longest(l1, l2))
print(lista2)

"""Izbaciti sve neparne brojeve iz liste [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]"""

lista = list(itertools.takewhile(lambda x: x<=10, itertools.count(1)))
lista = list(itertools.filterfalse(lambda x: x%2==0, lista))   #[i for i in lista if i%2 == 1]
print(lista)

"""Iz sortiranog niza izbaciti sve one manje od 5."""

lista = list(itertools.takewhile(lambda x: x<=10, itertools.count(1)))
lista = list(itertools.dropwhile(lambda x: x<=5, lista))
print(lista)

"""Iz sortiranog niza izdvojiti sve one manje od 5."""

lista = list(itertools.takewhile(lambda x: x<=10, itertools.count(1)))
lista = list(itertools.takewhile(lambda x: x<=5, lista))
print(lista)

lista = list(itertools.chain([1, 2, 3], [4, 5, 6], "abcd"))
print(lista)
#chain [1, 2, 3], [4, 5, 6], "abcd"-> [1, 2, 3], [4, 5, 6], ['a', 'b', 'c', 'd']
# ->[1, 2, 3, 4, 5, 6, 'a', 'b', 'c', 'd']

lista = list(itertools.chain.from_iterable([[1, 2], [4, True, 6] ,"abcd"]))
print(lista)
